import numpy as np

#------------------------------------get data------------------------------------#
parnames=('name','logT90','logEiso','alpha','logEp','logfeff-1','logsSFR','logM','XH','logR50','logOffset','Flight')
data=np.genfromtxt('data.csv', delimiter=',', comments='#', usecols=[1,2,3,4,5,6,7,8,9,10,11])
name=np.genfromtxt('data.csv', delimiter=',', comments='#', usecols=[0], dtype='S')

par=np.array([[1.6836283,52.615199,-1.0181675,2.1584613,-0.91256813,0.056753038,9.5186735,-0.70343511,0.26287058,-0.12373727,1.3703400], #lmean
             [0.59446099,1.0088713,0.33838821,0.47659109,0.34377950,0.72187004,0.80861296,0.61519574,0.31662215,0.44219167,np.nan], #lsigma
#             [-0.35881290,50.916791,-0.56600000,2.6308743,0.12853806,-0.53013409,9.8981818,-0.034444444,0.56413298,0.34115362,-5.6546151], #smean
             [-0.35881290,50.916791,-0.56600000,2.6308743,0.12853806,-0.53013409,9.8981818,-0.034444444,0.56413298,0.34115362,-4.70], #smean
             [0.56763789,0.93565896,0.26087216,0.42279106,0.37180602,1.0467810,0.83613417,0.16256623,0.29139178,0.44527556,np.nan]]) #ssigma

outpar=['pL','pS','logOdds_prompt','logOdds_host','logOdds']
pls=np.full((data.shape[0],5),np.nan)
Type=np.full(data.shape[0],'unknown',dtype=np.str('U8'))

functions=np.array(['G','G','G','G','G','G','G','G','G','G','F'])
#par_prompt=np.array(['logT90','logEiso','alpha','logEp','logfeff-1'])
#par_host=np.array(['logsSFR','logM','XH','logR50','logOffset','Flight'])

prior=np.array([0.92,0.08])

for i in range(data.shape[0]):
#   print i
   ii=(~np.isnan(data[i]))&(functions=='G')
   iif=(~np.isnan(data[i]))&(functions=='F')

   #pL
#   logLl=np.log(prior[0]) - 0.5 * np.sum(np.log(2. * np.pi * par[1][ii] ** 2)) - np.sum((data[i][ii]-par[0][ii]) ** 2 /2./ par[1][ii] ** 2)
   pL=prior[0]*np.prod(1./np.sqrt(2.*np.pi)/par[1][ii]/np.exp((data[i][ii]-par[0][ii])**2/2./par[1][ii] ** 2))
   #Flight
   if np.size(np.where(iif)) > 0:
      gam=par[0][iif] #index of exponential distribution
      A=gam/(np.exp(gam)-1.)
      pL=pL*A*np.exp(gam*data[i][iif])
   pls[i][0]=pL
#   logLl=logLl + np.sum(np.log(A*np.exp(gam*data[i][iif])))
#   pls[i][0]=np.exp(logLl) #pL

   #pS
#   logLs=np.log(prior[1]) - 0.5 * np.sum(np.log(2. * np.pi * par[3][ii] ** 2)) - np.sum((data[i][ii]-par[2][ii]) ** 2 /2./ par[3][ii] ** 2)
   pS=prior[1]*np.prod(1./np.sqrt(2.*np.pi)/par[3][ii]/np.exp((data[i][ii]-par[2][ii])**2/2./par[3][ii] ** 2))
   #Flight
   if np.size(np.where(iif)) > 0:
      gam=par[2][iif] #index of exponential distribution
      A=gam/(np.exp(gam)-1.)
      pS=pS*A*np.exp(gam*data[i][iif])
   pls[i][1]=pS
#   logLs=logLs + np.sum(np.log(A*np.exp(gam*data[i][iif])))
#   pls[i][1]=np.exp(logLs) #pS

   tot=pls[i][0]+pls[i][1]
   pls[i][0]=pls[i][0]/tot #pL
   pls[i][1]=pls[i][1]/tot #pS
   pls[i][4]=np.log10(pls[i][0]/pls[i][1]) #logOdds
   if pls[i][0] > pls[i][1]: 
      Type[i]='II'
   else:
      Type[i]='I'

   #Odd_prompt
   iip=(~np.isnan(data[i])) & (np.arange(11) <= 4) 
   pLp=prior[0]*np.prod(1./np.sqrt(2.*np.pi)/par[1][iip]/np.exp((data[i][iip]-par[0][iip])**2/2./par[1][iip] ** 2))
   pSp=prior[1]*np.prod(1./np.sqrt(2.*np.pi)/par[3][iip]/np.exp((data[i][iip]-par[2][iip])**2/2./par[3][iip] ** 2))
   pls[i][2]=np.log10(pLp/pSp) #logOdds_prompt

   #Odd_host
   iih=(~np.isnan(data[i])) & (functions=='G') & (np.arange(11) > 4) #as host parameters
   if np.size(np.where(iih)) > 0:
      pLh=prior[0]*np.prod(1./np.sqrt(2.*np.pi)/par[1][iih]/np.exp(((data[i][iih]-par[0][iih])/par[1][iih])**2/2.))
      pSh=prior[1]*np.prod(1./np.sqrt(2.*np.pi)/par[3][iih]/np.exp(((data[i][iih]-par[2][iih])/par[3][iih])**2/2.))
   else:
      pLh=prior[0]; pSh=prior[1] 
   iih=(~np.isnan(data[i])) & (functions=='F') & (np.arange(11) > 4) #as host parameters
   if np.size(np.where(iih)) > 0:
      gam=par[0][iih]; A=gam/(np.exp(gam)-1.)
      pLh=pLh*A*np.exp(gam*data[i][iih])
      gam=par[2][iih]; A=gam/(np.exp(gam)-1.)
      pSh=pSh*A*np.exp(gam*data[i][iih])
   pls[i][3]=np.log10(pLh/pSh) #logOdds_host

data_pls=np.append(data,pls,axis=1)
header=','
header=header.join(list(parnames)+list(outpar))+',Type'
with open('data_out.csv','w') as f:
  f.writelines(header+'\n')
  for i in np.arange(data.shape[0]):
     f.writelines(name[i]+',')
     for j in data_pls[i]:
        f.writelines(str(j))
        f.writelines(',')
     f.writelines(Type[i]+'\n')
